function [perm,sizes] = separ(A,ndom,marker,list,levels) 
%%
%% separates interface nodes from interior nodes in a partitioning
%% interface nodes are listed last.. 
%% [perm, sizes] output is the same as in map4.. 
%% 
sizes = levels(2:ndom+1) - levels(1:ndom); 
n = size(A,1); 
%% wrap up
    bw = n+1; 
    idx = 0; 
    for idom=1:ndom
        for k=levels(idom):levels(idom+1)-1 
            jnod = list(k) ;
            [i,j,r] = find(A(jnod,:));
            [i,j1,r] = find(A(:,jnod));
            j = union(i',j) ;
            interf = 0; 
            for k=1:length(j)
               jcol = j(k) ; 
               if (marker(jcol) ~= idom)  %%% interf, point
	          interf = 1;
                  break; 
                end
             end
	     if (interf == 0) 
         	   idx = idx+1; 
                   perm(idx) = jnod;
             else
                   bw = bw-1;
                   perm(bw) = jnod; 
                   sizes(idom) = sizes(idom) - 1;
            end
        end
     end 
%% done 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
